{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "(줄세우기)=\n",
    "# 2252 : 줄 세우기\n",
    "\n",
    "```{article-info}\n",
    ":avatar: /images/logos/my_favi.png\n",
    ":avatar-alt: supposed to be surdarla logo\n",
    ":avatar-link: https://surdarla.github.io\n",
    ":avatar-outline: muted\n",
    ":author: Surdarla\n",
    ":date: Nov 28 Tue 15:36, 2023\n",
    ":read-time: \"{sub-ref}`wordcount-minutes` min read\"\n",
    ":class-container: sd-p-2 sd-outline-muted sd-rounded-1\n",
    "```\n",
    "\n",
    "- <img src=\"https://d2gd6pc034wcta.cloudfront.net/tier/13.svg\" width=\"15\" height=\"15\"/> 골드 3\n",
    "\n",
    "| 시간제한 | 메모리제한 |  정답비율   |\n",
    "|:----:|:-----:|:-------:|\n",
    "|  2초  | 128MB | 56.930% |\n",
    "\n",
    "## 문제\n",
    "\n",
    "N명의 학생들을 키 순서대로 줄을 세우려고 한다. 각 학생의 키를 직접 재서 정렬하면 간단하겠지만, 마땅한 방법이 없어서 두 학생의 키를 비교하는 방법을 사용하기로 하였다. 그나마도 모든 학생들을 다 비교해 본 것이 아니고, 일부 학생들의 키만을 비교해 보았다.\n",
    "\n",
    "일부 학생들의 키를 비교한 결과가 주어졌을 때, 줄을 세우는 프로그램을 작성하시오.\n",
    "\n",
    "## input\n",
    "\n",
    "- 첫째 줄에 N(1 ≤ N ≤ 32,000), M(1 ≤ M ≤ 100,000)이 주어진다. \n",
    "- M은 키를 비교한 회수이다. 다음 M개의 줄에는 키를 비교한 두 학생의 번호 A, B가 주어진다. \n",
    "- 이는 학생 A가 학생 B의 앞에 서야 한다는 의미이다.\n",
    "\n",
    "학생들의 번호는 1번부터 N번이다.\n",
    "\n",
    "## output\n",
    "\n",
    "**첫째 줄에 학생들을 앞에서부터 줄을 세운 결과를 출력한다. 답이 여러 가지인 경우에는 아무거나 출력한다.**\n",
    "\n",
    "## think\n",
    "\n",
    "::::{div} sd-rounded-3 sd-border-2 sd-shadow-md sd-p-5 sd-m-5\n",
    "[위상정렬](위상정렬)을 이용해야 하는 것이라 못 박아 줬다. 키가 큰 학생은 작은 학생으로 선이 가지 않는 일정한 방향성(? 순서)를 가짐으로 순환하지 않는 그래프라고 할 수 있다. 이들에 대해서 정렬을 해야한다. 그럼 답이 여러가지 읺 경우도 아무거나 하나 출력하는 것 보니 역시 같은 등급의 순서의 노드가 있는 것임에 틀림이가 없다.\n",
    ":::{div} sd-text-right sd-text-muted\n",
    "-- from su\n",
    ":::\n",
    "::::"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## python "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [],
   "source": [
    "import sys, os\n",
    "\n",
    "problem_num = \"2252\"\n",
    "\n",
    "path = os.getcwd() + f\"\\\\txt\\\\{problem_num}\" + \".txt\"\n",
    "sys.stdin = open(path, \"r\")\n",
    "input = sys.stdin.readline"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [],
   "source": [
    "from collections import deque\n",
    "\n",
    "node, edge = map(int, input().split())\n",
    "indegrees = [0] * (node + 1)\n",
    "graph = [[] for i in range(node + 1)]\n",
    "\n",
    "for _ in range(edge):\n",
    "    in_, out_ = map(int, input().split())\n",
    "    graph[in_].append(out_)\n",
    "    indegrees[out_] += 1"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "3 4 1 2 "
     ]
    }
   ],
   "source": [
    "def topology_sort():\n",
    "    result = []\n",
    "    q = deque()\n",
    "    for i in range(1, node + 1):\n",
    "        if indegrees[i] == 0:\n",
    "            q.append(i)\n",
    "    while q:\n",
    "        now = q.popleft()\n",
    "        result.append(now)\n",
    "        for i in graph[now]:\n",
    "            # 해당 원소와 연결되 노드들의 진입차수 -1\n",
    "            indegrees[i] -= 1\n",
    "            if indegrees[i] == 0:\n",
    "                q.append(i)\n",
    "\n",
    "    for i in result:\n",
    "        print(i, end=\" \")\n",
    "\n",
    "\n",
    "topology_sort()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## javascript"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "```{code-block} javascript\n",
    ":caption: nodejs code\n",
    ":emphasize-lines: 14,34,24\n",
    ":lineno-start: 1\n",
    "\n",
    "    const problem_num = \"2252\";\n",
    "    const path = `${__dirname}\\\\txt\\\\${problem_num}.txt`;\n",
    "    // const path = \"/dev/stdin\";\n",
    "\n",
    "    const input = require(\"fs\").readFileSync(path, 'utf8').toString().trim().split('\\n');\n",
    "    let currentLine = 0;\n",
    "\n",
    "    function readLine() {\n",
    "        return input[currentLine++].split(' ').map(Number);\n",
    "    }\n",
    "\n",
    "    const [node, edge] = readLine();\n",
    "    let indegrees = Array(node + 1).fill(0);\n",
    "    let graph = Array.from({ length: node + 1 }, () => []);\n",
    "\n",
    "    for (let i = 0; i < edge; i++) {\n",
    "        const [in_, out_] = readLine();\n",
    "        graph[in_].push(out_);\n",
    "        indegrees[out_] += 1;\n",
    "    }\n",
    "\n",
    "    function topology_sort(node, indegrees) {\n",
    "        const result = [];\n",
    "        const q = []; // deque style\n",
    "        for (let i = 1; i < node + 1; i++) {\n",
    "            if (indegrees[i] == 0) {\n",
    "                q.push(i)\n",
    "            }\n",
    "        }\n",
    "        while (q.length) {\n",
    "            const now = q.shift();\n",
    "            result.push(now);\n",
    "            for (let i = 0; i < graph[now].length; i++) {\n",
    "                const nextNode = graph[now][i];\n",
    "                indegrees[nextNode] -= 1;\n",
    "                if (indegrees[nextNode] == 0) {\n",
    "                    q.push(nextNode);\n",
    "                }\n",
    "            }\n",
    "        }\n",
    "        return result;\n",
    "    }\n",
    "\n",
    "    result = topology_sort(node, indegrees);\n",
    "    console.log(result.join(' '));\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "1. array 생성방식이 파이썬이랑 좀 다르다\n",
    "2. 리스트 for 순회를 할때는 밑에 const로 const temp = list[i] 이런식으로 만들어서 사용해 줘야한다.\n",
    "3. javascript array는 기본적으로 deque처럼 사용할 수 있다."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Java\n",
    "\n",
    "```{code-block} java\n",
    ":caption: java code\n",
    "\n",
    "import java.io.*;\n",
    "import java.util.*;\n",
    "\n",
    "public class Main {\n",
    "    public static void main(String[] args) throws IOException {\n",
    "        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));\n",
    "        StringTokenizer st = new StringTokenizer(br.readLine());\n",
    "        int node = Integer.parseInt(st.nextToken());\n",
    "        int edge = Integer.parseInt(st.nextToken());\n",
    "\n",
    "        // 진입차수 배열 초기화\n",
    "        int[] indegrees = new int[node + 1];\n",
    "\n",
    "        // 그래프 초기화(list of ArrayList)\n",
    "        ArrayList<ArrayList<Integer>> graph = new ArrayList<>();\n",
    "        for (int i = 0; i <= node; i++) {\n",
    "            graph.add(new ArrayList<Integer>());\n",
    "        }\n",
    "\n",
    "        // input graph indegrees initialize\n",
    "        for (int i = 0; i < edge; i++) {\n",
    "            st = new StringTokenizer(br.readLine());\n",
    "            int in_ = Integer.parseInt(st.nextToken());\n",
    "            int out_ = Integer.parseInt(st.nextToken());\n",
    "            graph.get(in_).add(out_); // [i] 가 아니라 .get method로 index안에 것 가져옴\n",
    "            indegrees[out_]++;\n",
    "        }\n",
    "\n",
    "        ArrayList<Integer> result = new ArrayList<>();\n",
    "        Queue<Integer> q = new LinkedList<>();\n",
    "\n",
    "        for (int i = 1; i <= node; i++) {\n",
    "            if (indegrees[i] == 0) {\n",
    "                q.add(i);\n",
    "            }\n",
    "        }\n",
    "        while (!q.isEmpty()) {\n",
    "            int now = q.poll();\n",
    "            result.add(now);\n",
    "\n",
    "            for (int i = 0; i < graph.get(now).size(); i++) {\n",
    "                int nextNode = graph.get(now).get(i);\n",
    "                indegrees[nextNode]--;\n",
    "\n",
    "                if (indegrees[nextNode] == 0) {\n",
    "                    q.add(nextNode);\n",
    "                }\n",
    "            }\n",
    "        }\n",
    "        for (int i : result) {\n",
    "            System.out.println(i + \" \");\n",
    "        }\n",
    "    }\n",
    "}\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "```{raw} html\n",
    "<script\n",
    "   type=\"text/javascript\"\n",
    "   src=\"https://utteranc.es/client.js\"\n",
    "   async=\"async\"\n",
    "   repo=\"surdarla/surdarla.github.io\"\n",
    "   issue-term=\"pathname\"\n",
    "   theme=\"github-light\"\n",
    "   label=\"💬 comment\"\n",
    "   crossorigin=\"anonymous\"\n",
    "/>\n",
    "```"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": ".venv",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.11.4"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
